//Tell the Arduino where the sensor is hooked up
#include <SoftwareSerial.h>

const byte txPin = 9;
const byte rxPin = 8;

unsigned char Bluetooth_val;  //defining variable val
#define Lpwm_pin 3            //adjusting speed
#define Rpwm_pin 5            //adjusting speed  //
#define fire_pin 10
#define fire_pin2 11
int pinLB = 7;  // defining pin2 left rear
int pinLF = 6;  // defining pin4 left front
int pinRB = 2;  // defining pin7 right rear
int pinRF = 4;  // defining pin8 right front
unsigned char Lpwm_val = 255;
unsigned char Rpwm_val = 255;

SoftwareSerial mySerial(rxPin, txPin);

void M_Control_IO_config(void) {
  pinMode(pinLB, OUTPUT);     // pin 2
  pinMode(pinLF, OUTPUT);     // pin 4
  pinMode(pinRB, OUTPUT);     // pin 7
  pinMode(pinRF, OUTPUT);     // pin 8
  pinMode(Lpwm_pin, OUTPUT);  // pin 11 (PWM)
  pinMode(Rpwm_pin, OUTPUT);  // pin 10 (PWM)
}
void Set_Speed(unsigned char Left, unsigned char Right) {
  analogWrite(Lpwm_pin, Left);
  analogWrite(Rpwm_pin, Right);
}
void advance()  //  going forward
{
  digitalWrite(pinRB, HIGH);
  digitalWrite(pinRF, LOW);  //making motor move towards right front
  digitalWrite(pinLB, LOW);  //making motor move towards left rear
  digitalWrite(pinLF, HIGH);
}
void turnR()  //turning right(dual wheel)
{
  digitalWrite(pinRB, LOW);  // making motor move towards right rear
  digitalWrite(pinRF, HIGH);
  digitalWrite(pinLB, LOW);  // making motor move towards left rear
  digitalWrite(pinLF, HIGH);
}
void turnL()  //turning left(dual wheel)
{
  digitalWrite(pinRB, HIGH);  //making motor move towards right rear
  digitalWrite(pinRF, LOW);
  digitalWrite(pinLB, HIGH);  //making motor move towards left rear
  digitalWrite(pinLF, LOW);
}
void stopp()  //stop
{
  digitalWrite(pinRB, HIGH);
  digitalWrite(pinRF, HIGH);
  digitalWrite(pinLB, HIGH);
  digitalWrite(pinLF, HIGH);
}
void back()  //back up
{
  digitalWrite(pinRB, LOW);  //making motor move towards right rear
  digitalWrite(pinRF, HIGH);
  digitalWrite(pinLB, HIGH);
  digitalWrite(pinLF, LOW);  //making motor move towards left front
}
void fire() {
  digitalWrite(fire_pin, HIGH);
}
void fire2() {
  digitalWrite(fire_pin2, HIGH);
}

void peace2() {
  digitalWrite(fire_pin2, LOW);
}

void peace() {
  digitalWrite(fire_pin, LOW);
}

void setup() {
  mySerial.begin(9600);
  M_Control_IO_config();
  Set_Speed(Lpwm_val, Rpwm_val);
  Serial.begin(9600);  //initialized serial port , using Bluetooth as serial port, setting baud at 9600
  stopp();
}
void loop() {

  if (mySerial.available())  //to judge whether the serial port receives the data.
  {
    Bluetooth_val = mySerial.read();  //reading (Bluetooth) data of serial port,giving the value of val;
    switch (Bluetooth_val) {
      case 'U':
        advance();  //UP
        break;
      case 'D':
        back();  //back
        break;
      case 'L':
        turnL();  //Left
        break;
      case 'R':
        turnR();  //Right
        break;
      case 'S':
        stopp();  //stop
        break;
      case 'Z':
        fire();  //stop
        break;
      case 'X':
        peace();  //stop
        break;
      case 'Q':
        fire2();  //stop
        break;
      case 'W':
        peace2();  //stop
        break;
    }
  }
}
